/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */

/*  Fluent Bit
 *  ==========
 *  Copyright (C) 2015 Treasure Data Inc.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

#ifndef FLB_PLUGINS_H
#define FLB_PLUGINS_H

#include <mk_core.h>
#include <fluent-bit/flb_input.h>
#include <fluent-bit/flb_output.h>
#include <fluent-bit/flb_config.h>

struct flb_input_plugin in_cpu_plugin;
struct flb_input_plugin in_mem_plugin;
struct flb_input_plugin in_kmsg_plugin;
struct flb_input_plugin in_xbee_plugin;
struct flb_input_plugin in_serial_plugin;
struct flb_input_plugin in_stdin_plugin;
struct flb_input_plugin in_mqtt_plugin;
struct flb_input_plugin in_lib_plugin;

struct flb_output_plugin out_es_plugin;
struct flb_output_plugin out_fluentd_plugin;
struct flb_output_plugin out_td_plugin;
struct flb_output_plugin out_stdout_plugin;


void flb_register_plugins(struct flb_config *config)
{
    struct flb_input_plugin *in;
    struct flb_output_plugin *out;

    in = &in_cpu_plugin;
    mk_list_add(&in->_head, &config->inputs);

    in = &in_mem_plugin;
    mk_list_add(&in->_head, &config->inputs);

    in = &in_kmsg_plugin;
    mk_list_add(&in->_head, &config->inputs);

    in = &in_xbee_plugin;
    mk_list_add(&in->_head, &config->inputs);

    in = &in_serial_plugin;
    mk_list_add(&in->_head, &config->inputs);

    in = &in_stdin_plugin;
    mk_list_add(&in->_head, &config->inputs);

    in = &in_mqtt_plugin;
    mk_list_add(&in->_head, &config->inputs);

    in = &in_lib_plugin;
    mk_list_add(&in->_head, &config->inputs);


    out = &out_es_plugin;
    mk_list_add(&out->_head, &config->outputs);

    out = &out_fluentd_plugin;
    mk_list_add(&out->_head, &config->outputs);

    out = &out_td_plugin;
    mk_list_add(&out->_head, &config->outputs);

    out = &out_stdout_plugin;
    mk_list_add(&out->_head, &config->outputs);


}

#endif
